
public class tree<T extends Comparable<T>> {
	Node<T> root;	//root node
	
	//tree constructor
	public tree(){
		root = null;
	}
	
	public void insert(T input){
		//method insert(...) requires implementation
	}
	public T search(T query){
		//method search(....) requires implementation
	}
	
	//print the tree to terminal
	public void print(){ traverse_print(root); }
	public void traverse_print(Node<T> n){
		System.out.println(n);
		if(n.getLeft() != null){ traverse_print(n.getLeft());}
		if(n.getRight() != null){traverse_print(n.getRight());}
	}
	
	//print the tree formatted for graphing by dot
	public void print_dot() { 
		System.out.println("Digraph BST {");
		print_dot(root); 
		System.out.println("}");
	}
	public void print_dot(Node<T> n){
		if(n == null){ return; }
		if(n.getLeft() != null){
			System.out.println("\t"+n.getData()+" -> "+n.getLeft().getData());
			print_dot(n.getLeft());
		}
		if(n.getRight() != null){
			System.out.println("\t"+n.getData()+" -> "+n.getRight().getData());
			print_dot(n.getRight());
		}
	}

}
